/**
# V threshold for saint-venant
*/


double cheat_threshold = 16; // Valeur max de u souhaitée
scalar cheat[];

event cheat_code( i++ ){
	#if IMPLICIT 
  	compute_u();
  	#endif
  foreach(){	  
    if( norm(u) > cheat_threshold ){
    	cheat[] = 1;
    	foreach_dimension(){
    		u.x[] /= norm(u)/cheat_threshold;
      	
#if IMPLICIT
			if (h[] > dry )
					q.x[] = q.x[]*h[];
				else
					q.x[] = 0;
#endif
		}
     }
  }
}

event init( i = 0 )
  fprintf(stderr,"# cheat-code activated , threshold = %lf\n",cheat_threshold);

